import request from '/@/utils/request';
import Http from '/@/utils/net/Http';
import Menu from '../Menu';
import { Session } from '/@/utils/storage';

let menus:any = []; 
/**
 * 以下为模拟接口地址，gitee 的不通，就换自己的真实接口地址
 *
 * （不建议写成 request.post(xxx)，因为这样 post 时，无法 params 与 data 同时传参）
 *
 * 后端控制菜单模拟json，路径在 https://gitee.com/lyt-top/vue-next-admin-images/tree/master/menu
 * 后端控制路由，isRequestRoutes 为 true，则开启后端控制路由
 * @method getAdminMenu 获取后端动态路由菜单(admin)
 * @method getTestMenu 获取后端动态路由菜单(test)
 */
export function useMenuApi() {
	return {
		getMenuAdmin: async (params?: object) => {
			//TODO: 要改成远程获取
			let res: any = await Menu.getList();
			menus = res.data.menu;
			// Session.set('menus',menus);
			// backEndTest(menus,res.data.role);
			console.log('menus',menus);
			let menu = {
				code: 0,
				type: "adminMenu",
				data: menus,
				role: res.data.role
			}
			console.log("menu result", menu);
			return menu;
		},
		getAdminMenu: (params?: object) => {
			return request({
				url: '/gitee/lyt-top/vue-next-admin-images/raw/master/menu/adminMenu.json',
				method: 'get',
				params,
			});
		},
		getTestMenu: (params?: object) => {
			return request({
				url: '/gitee/lyt-top/vue-next-admin-images/raw/master/menu/testMenu.json',
				method: 'get',
				params,
			});
		},
	};
}

// export function backEndTest(routers: any,roles: any) {
// 	routers.forEach((item:any,index:number)=>{
// 		item.isHide = true;
// 		item.meta.roles[0] = 'common';
// 		roles.forEach((item2:any)=>{
// 			if(item2==item.name){
// 				item.isHide = false;
// 				item.meta.roles[0] = 'admin';
// 			}
// 		})
// 		if(item.children){
// 			backEndTest(item.children,roles);
// 		}
// 		return item;
// 	})
// }
