import axios from 'axios';
import { ElMessage, ElMessageBox } from 'element-plus';
import { Session } from '/@/utils/storage';
import config from '../config';
import router from '../router';

// 配置新建一个 axios 实例
const service = axios.create({
	baseURL: config.host,// import.meta.env.VITE_API_URL as any,
	timeout: 50000,
	headers: { 'Content-Type': 'application/json' },
});

// 添加请求拦截器
service.interceptors.request.use(
	(config) => {
		console.log('config=>',config);
		// config.headers.common['_timestamp'] = config.params._timestamp;
		// config.headers.common['_sign'] = config.params._sign;
		// delete config.params._timestamp;
		// delete config.params._sign;
		// 在发送请求之前做些什么 token
		if (Session.get('token')) {
			// config.headers.common['token'] = `${Session.get('token')}`;
		}
		if (Session.get('CurrentAdminId')) {
			// config.headers.common['CurrentAdminId'] = `${Session.get('CurrentAdminId')}`;
		}
        const userInfo = Session.get("userInfo");
        if(userInfo){
            // config.headers.common['type'] = userInfo.type;
        }
		return config;
	},
	(error) => {
		// 对请求错误做些什么
		return Promise.reject(error);
	}
);

// 添加响应拦截器
service.interceptors.response.use(
	(response) => {
		// 对响应数据做点什么
		const res = response.data;
		//console.log("service.interceptors.response", response, res);
		if (res.code && res.code !== 0) {
			// 刷新页面
			if (res.code === 555) {
				// console.log('window.location.host',window.location.host);
				// console.log('window.location.pathname',window.location.pathname);
				// console.log('window.location.hash',window.location.hash);
				// console.log('window.location.href',window.location.href);
				// window.location.hash = '#/home';
				// setTimeout(()=>{
				// 	window.location.href = window.location.host+window.location.pathname+'#/home';
				// },500)
			}
			// `token` 过期或者账号已在别处登录
			// res.code < 100 || 
			if (res.code === 401 || res.code === 4001) {
				// Session.clear(); // 清除浏览器全部临时缓存
				// window.location.href = '/'; // 去登录页
				ElMessageBox.alert('你已被登出，请重新登录', '提示', {})
					.then(() => {
						Session.clear(); // 清除浏览器全部临时缓存
						window.location.href = '/'; // 去登录页
					 })
					.catch(() => { });
			}
			return response.data;
			// return Promise.reject(service.interceptors.response);
		} else {
			return response.data;
		}
	},
	(error) => {
		console.log("service.interceptors.error", error);
		// 对响应错误做点什么
		if (error.message.indexOf('timeout') != -1) {
			ElMessage.error('网络超时');
		} else if (error.message == 'Network Error') {
			ElMessage.error('网络连接错误');
		} else {
			if (error.response.data) ElMessage.error(error.response.statusText);
			else ElMessage.error('接口路径找不到');
		}
		return Promise.reject(error);
	}
);
// 导出 axios 实例
export default service;
